package ru.kristall.alfresco.module.bg.constraints;

import java.util.ArrayList;
import java.util.List;

import org.alfresco.model.ContentModel;
import org.alfresco.service.cmr.repository.InvalidNodeRefException;
import org.alfresco.service.cmr.repository.NodeRef;
import org.alfresco.service.cmr.repository.NodeService;
import org.alfresco.service.cmr.repository.StoreRef;
import org.alfresco.service.cmr.search.ResultSet;
import org.alfresco.service.cmr.search.SearchService;
import org.apache.log4j.Logger;

import ru.kristall.alfresco.module.bg.Constants;
//import ru.eurekabpo.alfresco.module.fardo.behaviours.FDDocumentBehaviour;

public class KriListOfValuesService {
   private NodeService nodeService;
   private SearchService searchService;
   private Logger logger = Logger.getLogger(KriListOfValuesService.class);

   public void setSearchService(SearchService searchService) {
      this.searchService = searchService;
   }

   public void setNodeService(NodeService nodeService) { this.nodeService = nodeService; }

   public List<String> getAllowedValues(String constraintName) {
      List<String> values = new ArrayList<String>();
      try {
         StoreRef storeRef = StoreRef.STORE_REF_WORKSPACE_SPACESSTORE;
         String templPath = Constants.TEMPLATE_PATH;
         logger.debug("Find templates at "+"PATH:\"" + templPath + "/*\"");
         ResultSet resultSet = searchService.query(storeRef, SearchService.LANGUAGE_LUCENE, "PATH:\"" + templPath + "/*\"");
         for (NodeRef nodeRef : resultSet.getNodeRefs()) {
            try{
              values.add((String) nodeService.getProperty(nodeRef, ContentModel.PROP_NAME));
            }
            catch(InvalidNodeRefException ex){ logger.error(ex);  }
         }
      } catch (Exception e) { logger.error("Error", e); }
      return values;
   }
}